//******************************************************************************
//! @file $Id: lin_drv.c 581 2008-02-25 10:23:47Z jtellier $
//!
//! 쌠 (c) 2008 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɊւĂlicense.txţقǂ݂B
//!
//! @brief ̧ق͈ȉ̒ʊ֐(ײ)܂݂܂B
//!			- LIN/UARTLIN
//!			- ATmega32/64/M1/C1p
//!			- ATtiny167p
//!
//! ̧قAVRStudio-413571/WinAVR-20071221ŊmF܂B
//!
//******************************************************************************
//_____ ݸٰ ________________________________________________________________
#include "lin_drv.h"

//_____ ` ___________________________________________________________________

//_____ 錾 ___________________________________________________________________

//_____ ֐ ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn lin_init
//
//  ̊֐LINƕKvȂLIN荞݂܂B
//
//   : ֐2̈n܂B
//			- l_type	: \ɂAl_typeLIN_1X܂LIN_2X̂ǂ炩łB
//			- b_rate	: LINްڰ ڼ޽(LINBRR)l
//
//  ֐͈ȉԂ܂B
//			== 0 : sALIN`v܂B
//			!= 0 : s
//
//  x : Ȃ
//------------------------------------------------------------------------------
unsigned char lin_init (unsigned char l_type, unsigned long b_rate)
{
	// TxLINRxLINٱ (ޯ ڽwgp邽߂1)
	LIN_PORT_DIR &= ~(1<<LIN_INPUT_PIN );
	LIN_PORT_DIR &= ~(1<<LIN_OUTPUT_PIN);
	LIN_PORT_OUT |=  (1<<LIN_INPUT_PIN );
	LIN_PORT_OUT |=  (1<<LIN_OUTPUT_PIN);

	Lin_full_reset();
	Lin_set_baudrate(b_rate);

	if (l_type == LIN_1X)
	{
		Lin_1x_enable();
	}
	else if (l_type == LIN_2X)
	{
		Lin_2x_enable();
	}
	else
	{
		return 0;
	}
	// LIN荞݋쓮̏ꍇAȉ2sĂB
//	Lin_set_enable_it();
//	asm ("sei");

	return 1;
}

//------------------------------------------------------------------------------
//  @fn lin_tx_header
//
//  ̊֐͎ߓ_(ɰ)̎ƂLIN擪̑o𖽗߂܂B
//
//   : ֐3̈n܂B
//			- l_type	: \ɂAl_typeLIN_1X܂LIN_2X̂ǂ炩łB
//			- l_id		: LINʎqlBLIN_1X̏ꍇALINʎqɕ^
//						  ܂B
//			- l_len		: ŉ^΂ް ޲ĒA(Ȃ)^̒B
//						  ꂪl_idŕ邽߁ȀLIN_1XŎgp
//						  ܂B
//
//  ֐͈ȉԂ܂B
//			== 0 : sALIN`v܂B
//			!= 0 : 擪is̐擪M
//
//  x : Ȃ
//------------------------------------------------------------------------------
unsigned char lin_tx_header (unsigned char l_type, unsigned char l_id, unsigned char l_len)
{
	Lin_abort();	// 킪'lin_tx_response'܂'lin_rx_response'
					// ̏ꍇɗLpB̓삪sĂ鎞LINڼ޽ł
					// ݂֎~AIDݒ肷邱ƂłȂ
					// ƂɒӂĂB
					// ("ް̒f"̓Q)

	if (l_type == LIN_1X)
	{
		Lin_1x_set_id(l_id);                                                                                                                             
		Lin_1x_set_len(l_len);
	}
	else if (l_type == LIN_2X)
	{
		Lin_2x_set_id(l_id);				// LIN 2.xŉ^΂ꂽȂ
	}
	else
	{
		return 0;
	}

	Lin_tx_header();						// ߐݒ
	return 1;
}

//------------------------------------------------------------------------------
//  @fn lin_rx_response
//
//  ̊֐͎Ə]̐ߓ_(ɰ)̏]ƂLIN̎󂯎𖽗߂܂B
//
//   : ֐2̈n܂B
//			- l_type	: \ɂAl_typeLIN_1X܂LIN_2X̂ǂ炩łB
//			- l_len		: ŉ^΂ް ޲ĒA(Ȃ)^̒B
//						  ꂪl_idŕ邽߁ȀLIN_1XŎgp
//						  ܂B
//
//  ֐͈ȉԂ܂B
//			== 0 : sALIN`v܂B
//			!= 0 : Mis
//
//  x : Ȃ
//------------------------------------------------------------------------------
unsigned char lin_rx_response (unsigned char l_type, unsigned char l_len)
{
	if (l_type == LIN_1X)
	{                                                                                                                                   
		Lin_1x_set_type();					// ύXKv
	}
	else if (l_type == LIN_2X)
	{
		Lin_2x_set_type();					// ύXKv
		Lin_set_rx_len(l_len);                                                                                                                        
	}
	else
	{                                                                                                                                                  
		return 0;                                                                                                                                     
	}                                                                                                                                                         

	Lin_rx_response();						// ߐݒ
	return 1;                                                                                                                                                 
}

//------------------------------------------------------------------------------
//  @fn lin_tx_response
//
//  ̊֐͎܂͏]̐ߓ_(ɰ)̏]ƂLIN̑o𖽗߂܂B
//
//   : ֐3̈n܂B
//			- l_type	: \ɂAl_typeLIN_1X܂LIN_2X̂ǂ炩łB
//			- *l_data	: SRAMz߲B̔z͑Mް ޲Ă܂݂
//						  B
//			- l_len		: ŉ^΂ް ޲ĒA(Ȃ)^̒B
//						  ꂪl_idŕ邽߁ȀLIN_1XŎgp
//						  ܂B
//
//  ֐͈ȉԂ܂B
//			== 0 : sALIN`v܂B
//			!= 0 : Mis
//
//  x : Ȃ
//------------------------------------------------------------------------------
unsigned char lin_tx_response (unsigned char l_type, unsigned char *l_data, unsigned char l_len)
{                                                                                     
	unsigned char i;                                                                                                                                                         
                                                                                                                                                                         
	if (l_type == LIN_1X)
	{
		Lin_1x_set_type();					// ύXKv
	}
	else if (l_type == LIN_2X)
	{
		Lin_2x_set_type();					// ύXKv
		Lin_set_tx_len(l_len);                                                                                                                           
	}
	else
	{                                                                                                                                                     
		return 0;                                                                                                                                        
	}                                                                                                                                                            
                                                                                                                                                                 
	Lin_clear_index();						// ް
	for (i = 0; i < l_len; i++)
	{
		Lin_set_data(*l_data++);                                                                                                                         
	}                                                                                                                                                            
                                                                                                                                                                 
	Lin_tx_response();						// ߐݒ
	return 1;                                                                                                                                                    
}

//------------------------------------------------------------------------------
//  @fn lin_get_response
//
//  ̊֐LINMꂽɎMްɏՕǂ(ɂ)܂B̊֐
//  Lin_rx_response()̕tIȂ̂łB
//
//   : ֐1̈n܂B
//			- *l_data	: SRAMz߲B̔z͎Mް ޲Ă܂݂
//						  B
//
//  ̊֐͉Ԃ܂B
//
//  x : Ȃ
//------------------------------------------------------------------------------
void lin_get_response (unsigned char *l_data)
{
	unsigned char i, l_len;                                                                                                                                         
                                                                                                                                                                
	l_len = Lin_get_len();                                                                                                                           
	Lin_clear_index();                                                                                                                                  
	for (i = 0; i < l_len; i++)
	{
		(*l_data++) = Lin_get_data();                                                                                                           
	}                                                                                                                                                   
}                                                                                                                                                               
